Imports System.Collections.Generic
Imports System.Text

Class clsFuncs
	Public Shared Function ConvertTimezoneTimeFormat_FromDecimal(timezone As String, ByRef startTime As String, ByRef endTime As String) As Boolean
		Try
			Dim iHexTimezone As Long = Convert.ToInt64(timezone)

			' convert decimal to hex 
			Dim hexTimezone As String = iHexTimezone.ToString("X")

			Select Case hexTimezone.Length
				Case 6
					hexTimezone = "00" & hexTimezone
					Exit Select

				Case 7
					hexTimezone = "0" & hexTimezone
					Exit Select
				Case Else
					Exit Select
			End Select

			Dim hexStartTime As String = hexTimezone.Substring(0, 4)
			Dim hexEndTime As String = hexTimezone.Substring(4, 4)

			Dim iStartTime As Integer = Convert.ToInt32(hexStartTime, 16)
			Dim iEndTime As Integer = Convert.ToInt32(hexEndTime, 16)

			startTime = iStartTime.ToString()
			endTime = iEndTime.ToString()
			Return True
		Catch
			startTime = String.Empty
			endTime = String.Empty
			Return False
		End Try
	End Function

	Public Shared Function ConvertTimezoneTimeFormat_ToDecimal(timezone As String) As Long
		Dim StartTimeHour As Integer = Convert.ToInt32(timezone.Substring(0, 2))
		Dim StartTimeMinute As Integer = Convert.ToInt32(timezone.Substring(2, 2))
		Dim EndTimeHour As Integer = Convert.ToInt32(timezone.Substring(4, 2))
		Dim EndTimeMinute As Integer = Convert.ToInt32(timezone.Substring(6, 2))

		Dim iStartTime As Integer = StartTimeHour * 100 + StartTimeMinute
		Dim iEndTime As Integer = EndTimeHour * 100 + EndTimeMinute

		Dim hexStartTime As String = iStartTime.ToString("X")
		Dim hexEndTime As String = iEndTime.ToString("X")

		Select Case hexStartTime.Length
			Case 1
				hexStartTime = "000" & hexStartTime
				Exit Select
			Case 2
				hexStartTime = "00" & hexStartTime
				Exit Select
			Case 3
				hexStartTime = "0" & hexStartTime
				Exit Select
		End Select

		Select Case hexEndTime.Length
			Case 1
				hexEndTime = "000" & hexEndTime
				Exit Select
			Case 2
				hexEndTime = "00" & hexEndTime
				Exit Select
			Case 3
				hexEndTime = "0" & hexEndTime
				Exit Select
		End Select

		Return Convert.ToInt64(hexStartTime & hexEndTime, 16)
	End Function
End Class
